'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UnconnectedForm = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.mapStateToProps = mapStateToProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _reactAddonsPureRenderMixin = require('react-addons-pure-render-mixin');

var _reactAddonsPureRenderMixin2 = _interopRequireDefault(_reactAddonsPureRenderMixin);

var _config = require('../config');

var _config2 = _interopRequireDefault(_config);

var _actions = require('../actions');

var Actions = _interopRequireWildcard(_actions);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var actionTypes = _config2.default.actionTypes;
var selector = _config2.default.selector;
var UnconnectedForm = exports.UnconnectedForm = _react2.default.createClass({
  displayName: 'UnconnectedForm',

  mixins: [_reactAddonsPureRenderMixin2.default],

  getFormState: function getFormState() {
    var _props = this.props;
    var id = _props.id;
    var fields = _props.fields;
    var initialized = _props.initialized;
    var errors = _props.errors;

    return {
      id: id,
      fields: fields.toJS(),
      initialized: initialized,
      errors: errors
    };
  },

  onFieldChange: function onFieldChange(e) {
    var _props2 = this.props;
    var dispatch = _props2.dispatch;
    var id = _props2.id;
    var onChange = _props2.onChange;
    var validate = _props2.validate;

    dispatch(Actions.changeFieldValue({ id: id, onChange: onChange, validate: validate, element: e.target }));
  },

  onFieldFocus: function onFieldFocus(e) {
    this.handleFocusChange(e);
  },

  onFieldBlur: function onFieldBlur(e) {
    this.handleFocusChange(e);
  },

  handleFocusChange: function handleFocusChange(e) {
    var _props3 = this.props;
    var dispatch = _props3.dispatch;
    var id = _props3.id;

    dispatch(Actions.changeFocus(id, e.target, e.type));
  },

  onFormSubmit: function onFormSubmit(e) {
    e.preventDefault();
    var onSubmit = this.props.onSubmit;

    onSubmit && onSubmit(this.getFormState());
  },

  componentWillMount: function componentWillMount() {
    var _props4 = this.props;
    var dispatch = _props4.dispatch;
    var id = _props4.id;
    var fields = _props4.fields;
    var onChange = _props4.onChange;
    var validate = _props4.validate;

    if (!id) throw new Error('You forgot to provide form id');
    if (!fields) throw new Error('You forgot to provide form fields');
    dispatch(Actions.initForm({ id: id, fields: fields, onChange: onChange, validate: validate }));
  },

  componentWillUnmount: function componentWillUnmount() {
    var _props5 = this.props;
    var dispatch = _props5.dispatch;
    var id = _props5.id;

    dispatch({
      type: actionTypes.destroyForm,
      payload: { id: id }
    });
  },

  render: function render() {
    var _this = this;

    var _props6 = this.props;
    var children = _props6.children;
    var id = _props6.id;
    var fields = _props6.fields;
    var initialized = _props6.initialized;
    var moreErrors = _props6.moreErrors;

    if (!initialized) return null;

    return _react2.default.createElement(
      'form',
      { id: id, onSubmit: this.onFormSubmit },
      _react2.default.Children.map(children, function (el) {
        if (el.props) {
          if (el.props['hoth-form']) {
            var newProps = el.props['hoth-form'](_this.getFormState());
            return _react2.default.cloneElement(el, newProps);
          }
          var fieldProps = fields.get(el.props.name);
          if (fieldProps) {
            var props = {
              onChange: _this.onFieldChange,
              onFocus: _this.onFieldFocus,
              onBlur: _this.onFieldBlur,
              moreErrors: moreErrors && moreErrors[el.props.name]
            };
            if (fieldProps.fields) {
              if (el.type === 'select' || el.props.type === 'select') {
                props = _extends({}, props, fieldProps);
              } else if (!el.props.value) {
                var value = fieldProps.value;

                var newFieldProps = _objectWithoutProperties(fieldProps, ['value']);

                props = _extends({}, props, newFieldProps);
              } else {
                props = _extends({}, props, fieldProps.fields[el.props.value]);
              }
            } else {
              props = _extends({}, props, fieldProps);
            }
            return _react2.default.cloneElement(el, props);
          } else {
            return el;
          }
        } else {
          return el;
        }
      })
    );
  }
});

function mapStateToProps(state, ownProps) {
  var slice = selector(state);
  return {
    fields: slice.getIn([ownProps.id, 'fields']) || ownProps.fields,
    initialized: slice.getIn([ownProps.id, 'initialized']),
    errors: slice.getIn([ownProps.id, 'errors'])
  };
}

exports.default = (0, _reactRedux.connect)(mapStateToProps)(UnconnectedForm);